# -----------------------------------------------------------------------------
# Programm         : E c k e . p m
# -----------------------------------------------------------------------------
# Autor            : Christian Dhl
# Erstellt         : 10. Februar 2004
# Zuletzt gendert : 12. Februar 2004
# Aufgabe          : Eckenklasse
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
# Globale private Datei-Variablen:
# -----------------------------------------------------------------------------
my $Debug  = 0;


# -----------------------------------------------------------------------------
# Klasse           : E c k e
# abgeleitet von   : Basis
# -----------------------------------------------------------------------------
# Autor            : Christian Dhl
# Beschreibung     : Eine Ecken-Klasse.
# Attribute        : x   - X-Koordinate der Ecke
#                    y   - Y-Koordinate der Ecke
# Klassen-Methoden : new - Erstellt ein Objekt dieser Klasse.
# Objekt-Methoden  : x   - Getter / Setter
#                    y   - Getter / Setter
# -----------------------------------------------------------------------------
# 0.0.1 - 10.02.2004 - CD - erstellt
# -----------------------------------------------------------------------------
package Graph::GED::Ecke;

use strict;
use warnings;

use Data::Dumper;
use Graph::GED::Basis;

# -----------------------------------------------------------------------------
# Globale ffentliche Klassen-Variablen:
# -----------------------------------------------------------------------------
our @ISA   = ('Graph::GED::Basis');

sub new {
# -----------------------------------------------------------------------------
# Methode      : n e w
# Klasse       : Graph::GED::Ecke
# -----------------------------------------------------------------------------
# Autor        : Christian Dhl
# Aufgabe      : Erzeugt eine neue Ecke.
# Parameter    : Klasse
# Rckgabewert : Das geblesste neue Objekt.
# -----------------------------------------------------------------------------
# 0.0.1 - 08.02.2004 - CD - erstellt
# 0.0.2 - 10.02.2004 - CD - Vereinfachung durch Verwendung der Klasse Basis.
# -----------------------------------------------------------------------------

    my $self  = shift;
    my $class = (ref $self) || $self;

    #--------------------------------------------------------------------------
    # Ausgabe der Aufrufparameter:
    #--------------------------------------------------------------------------
    print "Graph::GED::Ecke::new\n",
          "\tself       = '$self'\n",
          "\tclass      = '$class'\n",
          "\tParameter  = @_\n",
          if $Debug > 1;


    #--------------------------------------------------------------------------
    # Objekt von der Basisklasse erzeugen lassen:
    #--------------------------------------------------------------------------
    $self = $class->SUPER::new();


    #--------------------------------------------------------------------------
    # Nun setzen wir noch ein paar Attribute:
    #--------------------------------------------------------------------------
    $self->x(-1);
    $self->y(-1);


    #--------------------------------------------------------------------------
    # ... und geben das erzeugte Objekt zurck:
    #--------------------------------------------------------------------------
    return $self;

} # sub Ecke::new


# -----------------------------------------------------------------------------
# The getter/setter methods:
# -----------------------------------------------------------------------------
sub x { return shift->_property('x', @_) }
sub y { return shift->_property('y', @_) }


return 1;

__END__

=head1 NAME

Graphen::GED::Ecke.pm - a module for a vertex of a graph

=head1 METHODS

=head2 class methods

=over

=item *

C<new> - creates a new Ecke objekt

=back

=head2 objekt methods

=over

=item *

C<x> - a mixed getter/setter for the attribute 'x' - the x coordinate

=item *

C<y> - a mixed getter/setter for the attribute 'y' - the x coordinate

=back

=head1 COPYRIGHT

Copyright 2004 Christian Duehl. All rights reserved.

This library is free software. You can redistribute it and/or
modify it under the same terms as perl itself.

=cut
